// Copyright (c) 2021, Pedro Quaresma <pedro@mat.uc.pt>

#include <iostream>

#include <cstdio>
#include <cstring> // permite a utilizao de funcoes que manipulam strings 

#include "cifrasSubstituicao.hpp" // Classe com as Cifras de Deslocamento

using namespace std;

int main(int argc, char *argv[]){
  
  //fl -> o ficheiro de leitura 
  //fe -> o ficheiro de escrita 
   
  FILE *fl,*fe;
  
  //verificar o nmero de argumento
  if(argc!=5) {
    cout << "Utilizao: \n\t\t ./encriptarDL nome_ficheiro_entrada nome_ficheiro_saida chave1 chave2\n\n"; 
    return(1); // erro nmero de argumento errado
  }
  
  //Declaraes das variveis
  char *mensnormal, *menscifrada;
  int ch,caracter,resultado;
  int chave1,chave2,valora,valorb;
  char caracteres[2];
  
   
  //copia do ficheiro de entrada
  mensnormal = argv[1];
  
  // funcao atoi() recebe uma string e devolve o inteiro que nela esta
  // representado
  chave1=atoi(argv[3]);
  chave2=atoi(argv[4]);
  
  //copia do ficheiro de saida
  menscifrada = argv[2];
  
  //abrir o ficheiro para a leitura
  fl = fopen(mensnormal,"r");
  
  //verificar se o ficheiro foi aberto ou nao
  //caso contrario o programa termina
  if(fl==NULL){
    cout << "Impossvel abrir o ficheiro " << argv[1] << endl;
    return(2); // erro, impossvel abrir o ficheiro de entrada
  }
   
  //Abrir o ficheiro para escrever a mensagem cifrada
  if((fe = fopen(menscifrada,"w"))==NULL){
    cout << "Impossvel criar o ficheiro " << menscifrada << endl;
    return(3); // erro, impossvel abrir o ficheiro de sada
  }
  
  //Aplicar a Cifra de Deslocamento Linear
  //para encriptar a mensagem

  CifrasSubstituicao cifraDL;
  
  while((ch=fgetc(fl)) != EOF){
    resultado=cifraDL.encriptarDL(ch,chave1,chave2);
    fprintf(fe,"%c",resultado);
  }
  
    
  //fechar os ficheiros  
  fclose(fl);
  fclose(fe);
  
  return (0);
}
